--generic static object
Static = Class{}

function Static:__init(x, y, w, h)
	self.x = x
	self.y = y
	self.w = w
	self.h = h

	Bump.addStatic(self)
end



--level geometry
Block = Static:extends{name = 'block'}

function Block:__init(x, y)
	self.super.__init(self, x, y, gameplay.block_size, gameplay.block_size)
end

function Block:draw(x, y)
	love.graphics.setColor(150, 150, 150, 255)
	love.graphics.rectangle('fill', self.x + x, self.y + y, self.w, self.h)
end



--spawn points
Spawn = Static:extends{name = 'spawn'}

function Spawn:__init(x, y)
	self.super.__init(self, x, y, gameplay.block_size, gameplay.block_size)
	self.r_amount = 0
end

function Spawn:update(dt)
	self.r_amount = self.r_amount - 255 * dt
	if self.r_amount < 0 then
		self.r_amount = 0
	end
end

function Spawn:collision(item, dx, dy)
	--flash when player touches
	if item.name == 'player' then
		self.r_amount = 255
	end
end

function Spawn:draw(x, y)
	love.graphics.setColor(self.r_amount, 255, 0, 255)
	love.graphics.rectangle('fill', self.x + x, self.y + y, self.w, self.h)
end



--hazards (read: spikes)
Hazard = Static:extends{name = 'hazard'}

function Hazard:__init(x, y)
	self.super.__init(self, x, y, gameplay.block_size, gameplay.block_size)
end

function Hazard:draw(x, y)
	love.graphics.setColor(255, 0, 0, 255)
	love.graphics.rectangle('fill', self.x + x, self.y + y, self.w, self.h)
end